require "DxLib"
require "tssLib"

local d = os.date("*t");
math.randomseed(d.sec);

dofile "stagedata.lua"

--SetGraphMode( 800 , 600 , 16 ) ;

ChangeWindowMode(1);
SetGraphMode( 640 , 496 , 32 ) ;

-- `ʂ𗠉ʂɃZbg
SetDrawScreen(0xfffffffe);

if( DxLib_Init() == -1 ) then os.exit() end; -- G[N璼ɏI

charGraph = LoadDivGraph( "char.bmp", 64, 8, 8,32,32 );
--bgGraph   = LoadDivGraph( "bg.bmp"  ,128,16, 8,16,16 );

char = LoadGraph( "tama.bmp" );

print( charGraph[0] );
--print( bgGraph[1] )
print( char )
eatDwav = LoadSoundMem( "eatD.wav" ) ;
eatPwav = LoadSoundMem( "eatP.wav" ) ;
eatEwav = LoadSoundMem( "eatE.wav" ) ;
movewav = LoadSoundMem( "move2.wav" );
ijikewav = LoadSoundMem( "ijike.wav" );

startmml = [[
#TITLE  <start>
#CHANNEL 4
#C   v15 o4 q0 p3 s1, -30 %3  l4 dedede dedede dddd
#D   v10 o4 q0 p3 s20 %2      l4 rdrdrd rdrdrd dddd
#A    t250 %0 @4 x1,2 l8 v15 o5 
    cgdcfdc r fadcfdc r cfdcfdc r l12 defdefdefg4.
#B  %1 l8 v8 o4 c2cc4 r e2ee4 r d2dd4 r d4g4d4g4
]]

mainmml = [[
#TITLE    <main>
#CHANNEL 1
#A t160 v10 %0  o4  l8 $ dc+
#END
]]

eatmml = [[
#TITLE    <eat>
#CHANNEL 1
#A t160  v10   %0  o4  l16   d ~a32
#END
#B       v10  %2  o4  l16  o3 d ~a32
]]

deadmml = [[
#TITLE    <dead>
#CHANNEL 1
#A t160 v10 %0 o5 l16 ee-d & e-dd- dd-c l16 cfgcfg
#END
]]


function drawText( x, y, s )
	for i = 1, #s do
		local c = string.byte(s, i);
		DrawGraph( x + i*16, y , bgGraph[c] ) ;
	end;
end;

GameData = {
    score = 0;
    highscore = 0;
    dotcount = 0;
    ijikecount = 0;
    stat = 0;    -- 0: title 1:start 2:game  3:out 4:restart 5:over 6: stage clear 7: coffee time
}

Back = {
    stage = {};

    stageinit = function(self)
        for i=0,30 do
            self.stage[i] = {};
            for j=0,27 do
                self.stage[i][j] = stagedata[i][j];
            end;
        end;
    end;

    draw = function(self)
        local i,j;
        for j=0,30 do
            for i=0,27 do
                DrawGraph( 16*i , 16*j , bgGraph[self.stage[j][i]] ) ;
--[[
                if self.stage[j][i] == 0 or self.stage[j][i] == 16 or self.stage[j][i] ==17 then
                       DrawBox( 16*i ,16*j, 16*i+16,16*j+16, 0x555555 ,0 );
                end;
]]--
            end;
        end;
--[[
		for i,j in pairs(medamadata) do

            local z = { {x=0,y=-1},{x=1,y=0},{x=0,y=1},{x=-1,y=0} };
			local x = i%32;
			local y = math.floor(i/32);

			for k = 1 , 4 do
	            if j[k] == 1 then  DrawBox( 16*(x+z[k].x),16*(y+z[k].y), 16*(x+z[k].x)+16,16*(y+z[k].y)+16, 0x555555 ,0 ); end;
			end;
		end;
]]--

		drawText( 16*28, 16*2, "HIGH SCORE" );
		drawText( 16*28, 16*3, string.format( "%10d", GameData.highscore ) );

		drawText( 16*28, 16*6, "SCORE" );
		drawText( 16*28, 16*7, string.format( "%10d", GameData.score ) );

		drawText( 16*28, 16*10, "REST" );
		drawText( 16*28, 16*11, string.format( "%3d", Player.stock ) );

		drawText( 16*28, 16*14, "STAGE" );
		drawText( 16*28, 16*15, string.format( "%3d", GameData.stage ) );

    end;

}

Player = {
    x = 13*16,
    y = 23*16+8,
	stock = 3;          -- c@
    stat = 1;           -- 1: ʏ 2:ꒆ
    statcount = 0;
    cur = 3,            --  0: 1:E  2: 3:
    imgCur = 1,
    animeSpeed = 4,
    animeSpeedCount = 0,
    imgDat = { [0]={ charGraph[0],charGraph[7],charGraph[8],charGraph[7] },
                   { charGraph[0],charGraph[3],charGraph[4],charGraph[3] },
                   { charGraph[0],charGraph[5],charGraph[6],charGraph[5] },
                   { charGraph[0],charGraph[1],charGraph[2],charGraph[1] },
    },
	deadDat = { [0]=charGraph[13],charGraph[12],charGraph[11],charGraph[10],charGraph[9],charGraph[8],charGraph[7],charGraph[0] };

    chk = {
      [0] = {y=-8,x=0 , mvy =-3, mvx= 0},
      [1] = {y= 0,x=8 , mvy = 0, mvx= 3},
      [2] = {y= 8,x=0 , mvy = 3, mvx= 0},
      [3] = {y= 0,x=-8, mvy = 0, mvx=-3},
    },

    dead = function(self)
		self.stat = 2;
		self.statcount = 700;
		self.stock = self.stock - 1;
    end;



    move = function(self)

		if self.stat == 2 then 
			self.statcount = self.statcount - 1;
			return;
		end;

        local Key = GetJoypadInputState( 0x1001 ) ;

        local zy = math.floor(self.y / 16 );
        local zx = math.floor(self.x / 16 );
--[[
        DrawBox( zx*16,(zy-1)*16,zx*16+16, (zy-1)*16+16, 0xFF0000, 0 );
        DrawBox( zx*16,(zy+1)*16,zx*16+16, (zy+1)*16+16, 0xFF0000, 0 );
        DrawBox( (zx-1)*16,zy*16,(zx-1)*16+16, zy*16+16, 0xFF0000, 0 );
        DrawBox( (zx-1)*16,zy*16,(zx+1)*16+16, zy*16+16, 0xFF0000, 0 );
]]--

--        print( self.x%16, self.y%16 );

--        if self.x%16 < 8 then
            if Key.UP then
                local n = Back.stage[zy-1][zx];
                if n == 0 or n==16 or n==17 then
                    self.cur = 0;
                    self.x = zx * 16+8;
                end;
            end;
            if Key.DOWN then
                local n = Back.stage[zy+1][zx];
                if n == 0 or n==16 or n==17 then
                    self.cur = 2;
                    self.x = zx * 16+8;
                end;
            end;
--        end;
--        if self.y%16 < 8 then
            if Key.RIGHT then
                local n = Back.stage[zy][zx+1];
                if n == 0 or n==16 or n==17 then
                    self.cur = 1;
                    self.y = zy * 16+8;
                end;
            end;
            if Key.LEFT then
                local n = Back.stage[zy][zx-1];
                if n == 0 or n==16 or n==17 then
                    self.cur = 3;
                    self.y = zy * 16+8;
                end;
            end;
--        end;
      
        local bx = math.floor( (self.x + self.chk[self.cur].x) / 16 );
        local by = math.floor( (self.y + self.chk[self.cur].y) / 16 );
--        print( bx, by );

        if Back.stage[by][bx] ==  0 or
           Back.stage[by][bx] == 16 or
           Back.stage[by][bx] == 17 then
            self.y = self.y + self.chk[self.cur].mvy;
            self.x = self.x + self.chk[self.cur].mvx;
        end;
		if by == 14 then
	        if bx < 0   then self.x = 448; end;
	        if bx > 27 then self.x = 0; end;
		end;
    end;

    draw = function(self)
		if self.stat == 1 then
	        self.animeSpeedCount=self.animeSpeedCount + 1
	        if self.animeSpeedCount==self.animeSpeed then
	            self.animeSpeedCount=0;
	            self.imgCur = self.imgCur + 1;
	            if self.imgCur > #self.imgDat then
	                self.imgCur = 1;
	            end;
	        end;
	        DrawGraph( self.x-16  , self.y-16 , self.imgDat[self.cur][self.imgCur] ) ;
--        DrawBox( self.x-16,self.y-16,self.x+16, self.y+16, 0x00FFFF ,0 );
--        DrawBox( self.x- 8,self.y- 8,self.x+ 8, self.y+ 8, 0x0000FF, 0 );
	    else
			if self.statcount > 0 then
				DrawGraph( self.x-16  , self.y-16 , self.deadDat[math.floor( self.statcount / 10 ) % 8] ) ;
				self.statcount = self.statcount - 1;
			end;
	    end;

    end;
};

Enemy = {
    pat = {},

    create  = function( self, typ, x, y,  img )
        self.pat[typ] = {};
        self.pat[typ].x = x;
        self.pat[typ].y = y;
        self.pat[typ].stat = 0;
        self.pat[typ].cur  = 0;
        self.pat[typ].count = 5;
        self.pat[typ].kosachk  = 0;
        self.pat[typ].img = img;
    end;

    movealgo = {
        -- k:ړł, zx, zy : ʒu
        [0] = function( self, typ, k, zx, zy )
            local r = 0;
            local py = math.floor(Player.y / 16 );
            local px = math.floor(Player.x / 16 );
           
            if math.abs(px-zx)<10 and math.abs(py-zy)<10 then
                --߂Âǐ
                if py < zy and k[1] == 1 then r = 1; end;
                if py > zy and k[3] == 1 then r = 3; end;
                if px < zx and k[2] == 1 then r = 2; end;
                if px > zx and k[4] == 1 then r = 4; end;
            else
                --pj(EɈړ͂)
            end;
            return r;
        end;
        [1] = function( self, typ, k, zx, zy )
            local r = 0;
            local py = math.floor(Player.y / 16 );
            local px = math.floor(Player.x / 16 );
            local z = { [0]={x=0,y=-3},{x=3,y=0},{x=0,y=3},{x=-3,y=0} };

            py = py + z[ Player.cur ].y;  -- P̈ړĂ݂
            px = px + z[ Player.cur ].x;

            if math.abs(px-zx)<10 and math.abs(py-zy)<10 then
                --߂Âǐ
                if py < zy and k[1] == 1 then r = 1; end;
                if py > zy and k[3] == 1 then r = 3; end;
                if px < zx and k[2] == 1 then r = 2; end;
                if px > zx and k[4] == 1 then r = 4; end;
            else
                --pj(Ɉړ͂)
                if k[4] == 1 then r = 4; end
            end;
            return r;
        end;
        [2] = function( self, typ, k, zx, zy )
            local r = 0;
            local py = math.floor(Player.y / 16 );
            local px = math.floor(Player.x / 16 );
            local z = { [0]={x=0,y=-3},{x=3,y=0},{x=0,y=3},{x=-3,y=0} };

            if math.abs(px-zx)<4 and math.abs(py-zy)<4 then
                --߂Âǐ
                if py < zy and k[1] == 1 then r = 1; end;
                if py > zy and k[3] == 1 then r = 3; end;
                if px < zx and k[2] == 1 then r = 2; end;
                if px > zx and k[4] == 1 then r = 4; end;
            else
                --pj(Ɉړ͂)
                if k[3] == 1 then r = 3; end
                if k[4] == 1 then r = 4; end
            end;
            return r;
        end;

        [3] = function( self, typ, k, zx, zy )  -- _ɑIł݂
            local r = 0;
            for i=1,4 do
                r = math.random(4);
                if k[r] == 0 then
                    r = 0
                end;
                if r ~= 0 then break; end;
            end;
            return r;
        end;
    },

    chk = {
      [0] = {y=-8,x=0 , mvy =-3, mvx= 0},
      [1] = {y= 0,x=8 , mvy = 0, mvx= 3},
      [2] = {y= 8,x=0 , mvy = 3, mvx= 0},
      [3] = {y= 0,x=-8, mvy = 0, mvx=-3},
    },

    movesub = function( self, typ )
        local zy = math.floor(self.pat[typ].y / 16 );
        local zx = math.floor(self.pat[typ].x / 16 );

        local mx, my;
      
        if self.pat[typ].stat == 0 then  -- 
            if self.pat[typ].cur == 0 then
                if Back.stage[zy-1][zx] ~= 0 then self.pat[typ].cur = 2; end;
            else
                if Back.stage[zy+1][zx] ~= 0 then
                    self.pat[typ].cur = 0;
                    self.pat[typ].count = self.pat[typ].count - 1;
                    if self.pat[typ].count < 0 then
                        self.pat[typ].stat = 1; --܂񐔂ŏo
                    end;
                end;
            end;
            my = self.chk[self.pat[typ].cur].mvy;
            mx = self.chk[self.pat[typ].cur].mvx;
        end;
        if self.pat[typ].stat == 1 then  -- o
            if zx >  14 then self.pat[typ].cur = 3; end;
            if zx == 14 then self.pat[typ].cur = 0; end;
            if zx <  13 then self.pat[typ].cur = 1; end;
            if zx == 13 then self.pat[typ].cur = 0; end;
            if zy < 12 then
                if zx == 13 then self.pat[typ].cur = 3; end;
                if zx == 14 then self.pat[typ].cur = 1; end;
                self.pat[typ].y = zy * 16 + 8;
                self.pat[typ].stat = 2;  --pj
            end;
            my = self.chk[self.pat[typ].cur].mvy;
            mx = self.chk[self.pat[typ].cur].mvx;
        end;
        if self.pat[typ].stat == 2 then  -- pj
            local kosa = kosadata[zy*32+zx];
            if  kosa ~= nil then   -- _
                if self.pat[typ].kosachk == 0 then
                    self.pat[typ].kosachk = 1; -- `FbNς
                    local k = {};
                    k[1] = kosa[1];
                    k[2] = kosa[2];
                    k[3] = kosa[3];
                    k[4] = kosa[4];
                    local s = ((self.pat[typ].cur + 2) % 4) + 1
                    k[s] = 0; -- ړɂ͖߂Ȃ
                    local r = self.movealgo[typ]( self, typ, k, zx, zy ); -- ^CvƂ̈ړ
                    if r == 0 then
                        for i=1,4 do
                            if k[i]==1 then r = i; end;
                        end;
                    end;
                    r = r - 1;
                    self.pat[typ].cur = r;
                    if r == 0 or r == 2 then
                        self.pat[typ].x = self.pat[typ].x - ( self.pat[typ].x % 16 ) + 8;
                    end;
                    if r == 1 or r == 3 then
                        self.pat[typ].y = self.pat[typ].y - ( self.pat[typ].y % 16 ) + 8;
                    end;
                  
                end;
            else
                self.pat[typ].kosachk = 0; --߂
            end;
            my = self.chk[self.pat[typ].cur].mvy;
            mx = self.chk[self.pat[typ].cur].mvx;
        end;
        if self.pat[typ].stat == 3 then  -- ڍs
--            self.pat[typ].cur = (self.pat[typ].cur + 2) % 4;    --]AAAǌ_ł蔲̂ŁAƂ肠߂Ƃ
            self.pat[typ].stat = 4;
            self.pat[typ].count = 5000;
        end;
        if self.pat[typ].stat == 4 or  -- 
           self.pat[typ].stat == 5 then  -- ߂
			local kosa;
			if self.pat[typ].stat == 4 then
				kosa= kosadata[zy*32+zx];
			else
				kosa= medamadata[zy*32+zx];		-- ڋʂ̏ꍇ
			end;
            if  kosa ~= nil then   -- _
                if self.pat[typ].kosachk == 0 then
                    self.pat[typ].kosachk = 1; -- `FbNς
                    local k = {};
                    k[1] = kosa[1];
                    k[2] = kosa[2];
                    k[3] = kosa[3];
                    k[4] = kosa[4];
                    local s = ((self.pat[typ].cur + 2) % 4) + 1
                    k[s] = 0; -- ړɂ͖߂Ȃ
                    local r = self.movealgo[3]( self, typ, k, zx, zy ); -- ^CvƂ̈ړ
                    if r == 0 then
                        for i=1,4 do
                            if k[i]==1 then r = i; end;
                        end;
                    end;
                    r = r - 1;
                    self.pat[typ].cur = r;
                    if r == 0 or r == 2 then
                        self.pat[typ].x = self.pat[typ].x - ( self.pat[typ].x % 16 ) + 8;
                    end;
                    if r == 1 or r == 3 then
                        self.pat[typ].y = self.pat[typ].y - ( self.pat[typ].y % 16 ) + 8;
                    end;
                  
                end;
            else
                self.pat[typ].kosachk = 0; --߂
            end;
	        if self.pat[typ].stat == 4 then  -- 
	            my = self.chk[self.pat[typ].cur].mvy * 0.7;
	            mx = self.chk[self.pat[typ].cur].mvx * 0.7;
			end;
	        if self.pat[typ].stat == 5 then  -- ߂
--				print( typ, self.pat[typ].cur );
	            my = self.chk[self.pat[typ].cur].mvy * 2;
	            mx = self.chk[self.pat[typ].cur].mvx * 2;

				if zy == 14 and ( zx == 12 or zx == 15 ) then 
					self.pat[typ].stat = 1;
					
				end;
	        end;
        end;

        -- warp speed down
        if zy == 14 then                --ʓ|Ȃ̂łׂA}bvɏׂ
            if zx < 6 or zx > 21 then
                my = my * 0.5;            --̂ƂƂAxɂȂH
                mx = mx * 0.5;
            end
        end;

        -- move
        self.pat[typ].y = self.pat[typ].y + my;
        self.pat[typ].x = self.pat[typ].x + mx;
       
         -- warp
        if self.pat[typ].x < 0 then self.pat[typ].x = 431; end;
        if self.pat[typ].x > 431 then self.pat[typ].x = 0; end;
      
    end;

    move = function( self )
        for i=0,3 do
            self:movesub(i);
        end;
    end;


    draw = function( self )
        local i;
        local img;
        for i=0,3 do
            if self.pat[i].stat == 3 or self.pat[i].stat == 4 then
                img = charGraph[20];
                if GameData.ijikecount < 50 then
                	if math.floor( GameData.ijikecount / 5 ) % 2 == 0 then
                		img = charGraph[21];
                	end;
                end;
            elseif self.pat[i].stat == 5 then  -- ڋ
                img = charGraph[22];
            else
                img = self.pat[i].img;
            end;
            DrawGraph( self.pat[i].x-16  , self.pat[i].y-16 , img ) ;
        end;
    end;

}

Fruit = {
    count = 0;
    timer = 0;
	pat = { charGraph[24],charGraph[25],charGraph[26],charGraph[27],charGraph[28],charGraph[29],charGraph[30],charGraph[31] };

	addcount = function( self )
		self.count = self.count + 1;
		if self.count % 100 == 0 then
			self.timer = 200;
		end;
	end;

    draw = function( self )
        local i;
        if self.timer > 0 then		-- timer 1ȏȂt[c\
			self.timer = self.timer - 1;
			i = GameData.stage % 8;	-- t[c̓Xe[WŌ߂
            DrawGraph( 208, 266 , self.pat[i] ) ;
        end;
    end;
    
    eatcheck = function( self )
	    local zy = math.floor(Player.y / 16 );
	    local zx = math.floor(Player.x / 16 );
		if self.timer > 0 then 		-- \
			if ( zx == 13 or zx == 14 ) and zy == 17 then		--t[cH
				PlaySoundMem( eatDwav, 1, 1 );
				GameData.score = GameData.score + 500;
				self.timer = 0;
			end;
		end;
    end;
}

function EatDot()
    local zy = math.floor(Player.y / 16 );
    local zx = math.floor(Player.x / 16 );

    local n = Back.stage[zy][zx];
    if n == 16 then 
		GameData.score = GameData.score +  100;
		GameData.dotcount = GameData.dotcount - 1;
        Back.stage[zy][zx] = 0;

		Enemy.pat[0].stat = 3;
		Enemy.pat[1].stat = 3;
		Enemy.pat[2].stat = 3;
		Enemy.pat[3].stat = 3;
		GameData.ijikecount = 500;

		Fruit:addcount();

		StopSoundMem( movewav );			-- ړ~߂
		StopSoundMem( ijikewav );			-- ~߂
		PlaySoundMem( ijikewav, 3, 1 );		-- Đ

    elseif n==17 then
--		TSGL_StopMusic();
--		TSGL_PlayMusicBuffer( eatmml );
		PlaySoundMem( eatDwav, 1, 1 );
        GameData.score = GameData.score +  10;
        GameData.dotcount = GameData.dotcount - 1;
        Back.stage[zy][zx] = 0;
		Fruit:addcount();
    end;
--	print( GameData.dotcount );
	return GameData.dotcount;
end;

function HitCheck()
    local py = math.floor(Player.y / 16 );
    local px = math.floor(Player.x / 16 );

	for i = 0, 3 do
		if Enemy.pat[i].stat ~= 5 then  -- ڋʂ̎̓X[
			ey = math.floor(Enemy.pat[i].y / 16);
			ex = math.floor(Enemy.pat[i].x / 16);
			if px == ex and  py == ey then	--
				if Enemy.pat[i].stat == 4 then  -- 
					PlaySoundMem( eatEwav, 1, 1 );
					GameData.score = GameData.score + 500;
					Enemy.pat[i].stat = 5;
				else  --ʏ
					Player:dead();
					return true;
				end;
			end;
		end;
	end;
	return false;
end;


Enemy:create( 0,256,230, charGraph[16] );
Enemy:create( 1,240,230, charGraph[17] );
Enemy:create( 2,256,250, charGraph[18] );
Enemy:create( 3,240,250, charGraph[19] );


function createtama()
	local ex = math.random( 640 );
	local ey = math.random( 480 );
	local edx = math.random( 3 );
	local edy = math.random( 3 );
	return 	{
		x = ex,
		y = ey,
		dx = edx,
		dy = edy,
	};
end;

tama = {}

for i = 1,1000 do 
	tama[i] = createtama();
end;

while( ProcessMessage() == 0 ) do
    if CheckHitKey(1) == 1 then break end;
    -- ʂ
    ClearDrawScreen() ;

	for i = 1, 1000 do
		tama[i].x = tama[i].x + tama[i].dx;
		tama[i].y = tama[i].y + tama[i].dy;
    	DrawGraph( tama[i].x  , tama[i].y , char ) ;
	end;

    -- ʂ̓e\ʂɔf
    ScreenFlip() ;

end;

-- cwCugp̏I
DxLib_End();

