require "DxLib"
require "tssLib"

local d = os.date("*t");
math.randomseed(d.sec);

-- dofile "stagedata.lua"

SetGraphMode( 1024 , 768 , 32 ) ;

ChangeWindowMode(1);
--SetGraphMode( 640 , 496 , 32 ) ;

-- `ʂ𗠉ʂɃZbg
SetDrawScreen(0xfffffffe);

SetUseFPUPreserveFlag(1);

if( DxLib_Init() == -1 ) then os.exit() end; -- G[N璼ɏI

charGraph = LoadDivGraph( "char.bmp", 64, 8, 8,32,32 );
bgGraph   = LoadDivGraph( "bg.bmp"  ,256,16,16,16,16 );
bgFont    = LoadDivGraph( "font.bmp",128,16, 8,16,16 );

BG_WIDTH  = 64;
BG_HEIGHT = 48;

BG_NO_NON =  0  -- ʘH  BG
BG_NO_DOT =  1  -- dot   BG
BG_NO_POW =  2  -- power BG
BG_NO_SLW =  3  -- slow  BG
BG_NO_WRP =  4  -- warp  BG
BG_NO_ORI =  6  -- B    BG
BG_NO_RES =  8  -- GBG

eatDwav  = LoadSoundMem( "eatD.wav"  );
eatPwav  = LoadSoundMem( "eatP.wav"  );
eatEwav  = LoadSoundMem( "eatE.wav"  );
movewav  = LoadSoundMem( "move2.wav" );
ijikewav = LoadSoundMem( "ijike.wav" );

startmml = [[
#TITLE  <start>
#CHANNEL 4
#C   v15 o4 q0 p3 s1, -30 %3  l4 dedede dedede dddd
#D   v10 o4 q0 p3 s20 %2      l4 rdrdrd rdrdrd dddd
#A    t250 %0 @4 x1,2 l8 v15 o5 
    cgdcfdc r fadcfdc r cfdcfdc r l12 defdefdefg4.
#B  %1 l8 v8 o4 c2cc4 r e2ee4 r d2dd4 r d4g4d4g4
]]

mainmml = [[
#TITLE    <main>
#CHANNEL 1
#A t160 v10 %0  o4  l8 $ dc+
#END
]]

eatmml = [[
#TITLE    <eat>
#CHANNEL 1
#A t160  v10   %0  o4  l16   d ~a32
#END
#B       v10  %2  o4  l16  o3 d ~a32
]]

deadmml = [[
#TITLE    <dead>
#CHANNEL 1
#A t160 v10 %0 o5 l16 ee-d & e-dd- dd-c l16 cfgcfg
#END
]]


function drawText( x, y, s )
	for i = 1, #s do
		local c = string.byte(s, i);
		DrawGraph( x + i*16, y , bgFont[c] ) ;
	end;
end;

GameData = {
    score = 0;
    highscore = 0;
    dotcount = 0;
    ijikecount = 0;
    stat = 0;    -- 0: title 1:start 2:game  3:out 4:restart 5:over 6: stage clear 7: coffee time
}

Back = {
    stage = {};

    stageinit = function(self, stageno )
		dofile( "stagedata.lua" );
    end;

    draw = function(self)
        local i,j;
        for j=0,48 do
        	if self.stage[j] == nil then break; end;
            for i=0,64 do
            	if self.stage[j][i] == nil then break; end;
                DrawGraph( 16*i , 16*j , bgGraph[self.stage[j][i]] ) ;
--[[
                if self.stage[j][i] == 0 or self.stage[j][i] == 16 or self.stage[j][i] ==17 then
                       DrawBox( 16*i ,16*j, 16*i+16,16*j+16, 0x555555 ,0 );
                end;
]]--
            end;
        end;
--[[
		for i,j in pairs(medamadata) do

            local z = { {x=0,y=-1},{x=1,y=0},{x=0,y=1},{x=-1,y=0} };
			local x = i%32;
			local y = math.floor(i/32);

			for k = 1 , 4 do
	            if j[k] == 1 then  DrawBox( 16*(x+z[k].x),16*(y+z[k].y), 16*(x+z[k].x)+16,16*(y+z[k].y)+16, 0x555555 ,0 ); end;
			end;
		end;
]]--

		drawText( 16*0, 16*46, "HIGH SCORE" );
		drawText( 16*0, 16*47, string.format( "%10d", GameData.highscore ) );

		drawText( 16*15, 16*46, "SCORE" );
		drawText( 16*15, 16*47, string.format( "%10d", GameData.score ) );

		drawText( 16*25, 16*46, "REST" );
		drawText( 16*25, 16*47, string.format( "%3d", Player.stock ) );

		drawText( 16*35, 16*46, "STAGE" );
		drawText( 16*35, 16*47, string.format( "%3d", GameData.stage ) );

    end;

}

Player = {
    x = 13*16,
    y = 23*16+8,
	stock = 3;          -- c@
    stat = 1;           -- 1: ʏ 2:ꒆ
    statcount = 0;
    cur = 3,            --  0: 1:E  2: 3:
    imgCur = 1,
    animeSpeed = 4,
    animeSpeedCount = 0,
    imgDat = { [0]={ charGraph[0],charGraph[7],charGraph[8],charGraph[7] },
                   { charGraph[0],charGraph[3],charGraph[4],charGraph[3] },
                   { charGraph[0],charGraph[5],charGraph[6],charGraph[5] },
                   { charGraph[0],charGraph[1],charGraph[2],charGraph[1] },
    },
	deadDat = { [0]=charGraph[15],charGraph[14],charGraph[13],charGraph[12],charGraph[11],charGraph[10],charGraph[9],charGraph[8],charGraph[7],charGraph[0] };

    chk = {
      [0] = {y=-8,x=0 , mvy =-3, mvx= 0},
      [1] = {y= 0,x=8 , mvy = 0, mvx= 3},
      [2] = {y= 8,x=0 , mvy = 3, mvx= 0},
      [3] = {y= 0,x=-8, mvy = 0, mvx=-3},
    },

    dead = function(self)
		self.stat = 2;
		self.statcount = 1000;
		self.stock = self.stock - 1;
    end;


	chkkey = function(self, k, c, zx, zy )
		local dx = {[0]=0 ,1,0,-1};
		local dy = {[0]=-1,0,1, 0};
		if k then
		    local n = Back.stage[zy+dy[c]][zx+dx[c]];
		    if n == BG_NO_NON or n==BG_NO_POW or n==BG_NO_DOT or n==BG_NO_SLW then
		        Player.cur = c;
				if c==0 or c==2 then Player.x = zx * 16+8; end;
				if c==1 or c==3 then Player.y = zy * 16+8; end;
		    end;
		end;
	end;


    move = function(self)

		if self.stat == 2 then 
--			self.statcount = self.statcount - 1;
			return;
		end;

        local Key = GetJoypadInputState( 0x1001 ) ;

        local zy = math.floor(self.y / 16 );
        local zx = math.floor(self.x / 16 );
--[[
        DrawBox( zx*16,(zy-1)*16,zx*16+16, (zy-1)*16+16, 0xFF0000, 0 );
        DrawBox( zx*16,(zy+1)*16,zx*16+16, (zy+1)*16+16, 0xFF0000, 0 );
        DrawBox( (zx-1)*16,zy*16,(zx-1)*16+16, zy*16+16, 0xFF0000, 0 );
        DrawBox( (zx-1)*16,zy*16,(zx+1)*16+16, zy*16+16, 0xFF0000, 0 );
]]--

--        print( self.x%16, self.y%16 );

		self:chkkey( Key.UP   , 0 ,zx, zy);
		self:chkkey( Key.RIGHT, 1 ,zx, zy);
		self:chkkey( Key.DOWN , 2 ,zx, zy);
		self:chkkey( Key.LEFT , 3 ,zx, zy);

        local bx = math.floor( (self.x + self.chk[self.cur].x) / 16 );
        local by = math.floor( (self.y + self.chk[self.cur].y) / 16 );
--        print( bx, by );

        if Back.stage[by][bx] == BG_NO_NON or
           Back.stage[by][bx] == BG_NO_POW or
           Back.stage[by][bx] == BG_NO_SLW or
           Back.stage[by][bx] == BG_NO_DOT then
            self.y = self.y + self.chk[self.cur].mvy;
            self.x = self.x + self.chk[self.cur].mvx;
        end;
        if Back.stage[by][bx] == BG_NO_WRP then
	        if bx < 0   then self.x = 448; end;
	        if bx > 27 then self.x = 0; end;
		end;
    end;

    draw = function(self)
		if self.stat == 1 then
	        self.animeSpeedCount=self.animeSpeedCount + 1
	        if self.animeSpeedCount==self.animeSpeed then
	            self.animeSpeedCount=0;
	            self.imgCur = self.imgCur + 1;
	            if self.imgCur > #self.imgDat then
	                self.imgCur = 1;
	            end;
	        end;
	        DrawGraph( self.x-16  , self.y-16 , self.imgDat[self.cur][self.imgCur] ) ;
--        DrawBox( self.x-16,self.y-16,self.x+16, self.y+16, 0x00FFFF ,0 );
--        DrawBox( self.x- 8,self.y- 8,self.x+ 8, self.y+ 8, 0x0000FF, 0 );
	    else
			if self.statcount > 0 then
				DrawGraph( self.x-16  , self.y-16 , self.deadDat[math.floor( self.statcount / 10 ) % 10] ) ;
				self.statcount = self.statcount - 1;
			end;
	    end;

    end;
};

Enemy = {
    pat = {},

    init = function( self, typ, x, y,  img, s, c, cnt )
        self.pat[typ] = {};
        self.pat[typ].x       = x;
        self.pat[typ].y       = y;
        self.pat[typ].stat    = s;
        self.pat[typ].cur     = c;
        self.pat[typ].count   = cnt;
        self.pat[typ].kosachk = 0;
        self.pat[typ].img     = img;
    end;

    movealgo = {
        -- k:ړł, zx, zy : ʒu
        [0] = function( self, typ, k, zx, zy )
            local r = -1;
            local py = math.floor(Player.y / 16 );
            local px = math.floor(Player.x / 16 );
           
            if math.abs(px-zx)<10 and math.abs(py-zy)<10 then
                --߂Âǐ
                if py < zy and k[0] == 1 then r = 0; end;
                if py > zy and k[2] == 1 then r = 2; end;
                if px < zx and k[1] == 1 then r = 1; end;
                if px > zx and k[3] == 1 then r = 3; end;
            else
                --pj(EɈړ͂)
            end;
            return r;
        end;
        [1] = function( self, typ, k, zx, zy )
            local r = -1;
            local py = math.floor(Player.y / 16 );
            local px = math.floor(Player.x / 16 );
            local z = { [0]={x=0,y=-3},{x=3,y=0},{x=0,y=3},{x=-3,y=0} };

            py = py + z[ Player.cur ].y;  -- P̈ړĂ݂
            px = px + z[ Player.cur ].x;

            if math.abs(px-zx)<10 and math.abs(py-zy)<10 then
                --߂Âǐ
                if py < zy and k[0] == 1 then r = 0; end;
                if py > zy and k[2] == 1 then r = 2; end;
                if px < zx and k[1] == 1 then r = 1; end;
                if px > zx and k[3] == 1 then r = 3; end;
            else
                --pj(Ɉړ͂)
--                if k[4] == 1 then r = 4; end
            end;
            return r;
        end;
        [2] = function( self, typ, k, zx, zy )
            local r = -1;
            local py = math.floor(Player.y / 16 );
            local px = math.floor(Player.x / 16 );

            if math.abs(px-zx)<4 and math.abs(py-zy)<4 then
                --߂Âǐ
                if py < zy and k[0] == 1 then r = 0; end;
                if py > zy and k[2] == 1 then r = 2; end;
                if px < zx and k[1] == 1 then r = 1; end;
                if px > zx and k[3] == 1 then r = 3; end;
            else
                --pj(Ɉړ͂)
                if k[2] == 1 then r = 2; end
                if k[3] == 1 then r = 3; end
            end;
            return r;
        end;

        [3] = function( self, typ, k, zx, zy )  -- _ɑIł݂
            local r = -1;
            for i=0,3 do
                r = math.random(4)-1;
                if k[r] == 0 then
                    r = -1
                end;
                if r ~= -1 then break; end;
            end;
            return r;
        end;
        
        [4] = function( self, typ, k, zx, zy ) -- ߂
			-- ڋʃ[gf[^ɏ]ē
			print( "zy=",zy , "zx=",zx, "k=", k[0],k[1],k[2],k[3] );
			if medama_route[zy]~=nil and medama_route[zy][zx]~=nil then
				print( "medama_route[zy][zx]=",medama_route[zy][zx] );
				return medama_route[zy][zx];
			end;
			-- ΃_
            local r = -1;
            for i=0,3 do
                r = math.random(4)-1;
                if k[r] == 0 then
                    r = -1
                end;
                if r ~= -1 then break; end;
            end;
            return r;
        end;
    },

    chk = {
      [0] = {y=-8,x=0 , mvy =-3, mvx= 0},
      [1] = {y= 0,x=8 , mvy = 0, mvx= 3},
      [2] = {y= 8,x=0 , mvy = 3, mvx= 0},
      [3] = {y= 0,x=-8, mvy = 0, mvx=-3},
    },

	haikai = function(self,typ)
--		print( "ene["..typ.."]" );
		local kosa={[0]=0,0,0,0};
		local dt={[0]={x=0,y=-1},{x=1,y=0},{x=0,y=1},{x=-1,y=0}};
		local zx = self.pat[typ].x%16;
		local zy = self.pat[typ].y%16;
		local my = self.chk[self.pat[typ].cur].mvy;
		local mx = self.chk[self.pat[typ].cur].mvx;

		if zx <= 3 or zx >= 12 or zy <= 3 or zy >= 12 then
			return mx, my;
		end;
        local y = math.floor(self.pat[typ].y / 16 );    -- + dt[self.pat[typ].cur].y;
        local x = math.floor(self.pat[typ].x / 16 );    -- + dt[self.pat[typ].cur].x;

		-- łɃ`FbNς
--		print( "kosachk=", self.pat[typ].kosachk, y * BG_WIDTH + x );
		if self.pat[typ].kosachk == y * BG_WIDTH + x then
			return mx, my;
		end;

		if Back.stage[y]==nil or Back.stage[y][x]==nil then return 0, buf end;
		local b = Back.stage[y][x];
		local cnt = 0;
		if b == BG_NO_NON or b == BG_NO_POW or b == BG_NO_SLW or b == BG_NO_DOT then
			for i=0,3 do
				if Back.stage[y+dt[i].y]~=nil then
					b = Back.stage[y+dt[i].y][x+dt[i].x];
					if b~=nil then
						if b == BG_NO_NON or b == BG_NO_POW or b == BG_NO_SLW or b == BG_NO_DOT then 
							cnt = cnt + 1;
							kosa[i] = 1;
						end;
					end;
				end;
			end;
		end;

		if cnt > 0 then
--			print( "kosa", kosa[0],kosa[1],kosa[2],kosa[3], "cur=", self.pat[typ].cur );
			if cnt == 1 then  -- s~܂Ȃt^[
				for i=0,3 do if kosa[i]==1 then self.pat[typ].cur=i; break; end; end;
			else
				kosa[(self.pat[typ].cur + 2) % 4] = 0; 						-- U^[֎~
				local r;
				if self.pat[typ].stat == 5 then
					r = self.movealgo[4]( self, typ, kosa, x, y );		-- ڋ
				else
					r = self.movealgo[typ]( self, typ, kosa, x, y );	-- ^CvƂ̈ړ
				end;
				if r == -1 then
					for i=0,3 do
						if kosa[i]==1 then r = i; end;
					end;
				end;
				self.pat[typ].cur = r;				-- VZbg

				-- ړ␳
				if r == 0 or r == 2 then
					self.pat[typ].x = self.pat[typ].x - ( self.pat[typ].x % 16 ) + 8;
				end;
				if r == 1 or r == 3 then
					self.pat[typ].y = self.pat[typ].y - ( self.pat[typ].y % 16 ) + 8;
				end;
			end;
		end;
		print( "self.pat["..typ.."].cur="..self.pat[typ].cur );
		my = self.chk[self.pat[typ].cur].mvy;
		mx = self.chk[self.pat[typ].cur].mvx;
		self.pat[typ].kosachk = y * BG_WIDTH + x;
		return mx,my;
	end;

    movesub = function( self, typ )
        local zy = math.floor(self.pat[typ].y / 16 );
        local zx = math.floor(self.pat[typ].x / 16 );

        local mx = 0;
        local my = 0;
      
        if self.pat[typ].stat == 0 then  -- 
            if self.pat[typ].cur == 0 then
                if Back.stage[zy-1][zx] ~= 0 then self.pat[typ].cur = 2; end;
            else
                if Back.stage[zy+1][zx] ~= 0 then
                    self.pat[typ].cur = 0;
                    self.pat[typ].count = self.pat[typ].count - 1;
                    if self.pat[typ].count < 0 then
                        self.pat[typ].stat = 1; --܂񐔂ŏo
                    end;
                end;
            end;
            my = self.chk[self.pat[typ].cur].mvy;
            mx = self.chk[self.pat[typ].cur].mvx;
        end;
        if self.pat[typ].stat == 1 then  -- o
            if zx >  PRISON_X[2] then self.pat[typ].cur = 3; end;
            if zx == PRISON_X[2] then self.pat[typ].cur = 0; end;
            if zx <  PRISON_X[1] then self.pat[typ].cur = 1; end;
            if zx == PRISON_X[1] then self.pat[typ].cur = 0; end;
            if zy == PRISON_Y then
--                if zx == 13 then self.pat[typ].cur = 3; end;
--                if zx == 14 then self.pat[typ].cur = 1; end;
                self.pat[typ].y = zy * 16 + 8;
                self.pat[typ].stat = 2;  --pj
            end;
            my = self.chk[self.pat[typ].cur].mvy;
            mx = self.chk[self.pat[typ].cur].mvx;
        end;
        if self.pat[typ].stat == 2 then  -- pj
			mx,my = self:haikai(typ);
        end;
        if self.pat[typ].stat == 3 then  -- ڍs
            self.pat[typ].cur = (self.pat[typ].cur + 2) % 4;    --]
			self.pat[typ].kosachk = 0;
            self.pat[typ].stat = 4;
            self.pat[typ].count = 5000;
        end;
        if self.pat[typ].stat == 4 then  -- 
			mx,my = self:haikai(typ);
			my = my * 0.7;		-- x_E
			mx = mx * 0.7;
		end;
        if self.pat[typ].stat == 5 then  -- ߂
			-- B`FbN
			if Back.stage[zy-1][zx] == BG_NO_RES then
				self.pat[typ].stat = 0;						-- ړɖ߂
				self.pat[typ].count= 0;						-- Oɏo
				self.pat[typ].cur  = 0;						-- ړ
			else
				mx,my = self:haikai(typ);
				my = my * 2;		-- 2{ړ
				mx = mx * 2;
			end;
        end;

        -- warp speed down
        if Back.stage[zy]~=nil and Back.stage[zy][zx] == BG_NO_SLW then
			my = my * 0.5;            --̂ƂƂAxɂȂH
			mx = mx * 0.5;
        end;

        -- move
        self.pat[typ].y = self.pat[typ].y + my;
        self.pat[typ].x = self.pat[typ].x + mx;
       
         -- warp
        if Back.stage[zy]~=nil and Back.stage[zy][zx] == BG_NO_WRP then
	        if self.pat[typ].x < 0 then self.pat[typ].x = 431; end;
	        if self.pat[typ].x > 431 then self.pat[typ].x = 0; end;
		end;
      
    end;

    move = function( self )
        for i=0,3 do
            self:movesub(i);
--			print( "enemy[" .. i .. "].stat = ".. self.pat[i].stat .. "    ");
        end;
--		print("\n" );
    end;


    draw = function( self )
        local i;
        local img;
        for i=0,3 do
            if self.pat[i].stat == 3 or self.pat[i].stat == 4 then
                img = charGraph[20];
                if GameData.ijikecount < 50 then
                	if math.floor( GameData.ijikecount / 5 ) % 2 == 0 then
                		img = charGraph[21];
                	end;
                end;
            elseif self.pat[i].stat == 5 then  -- ڋ
                img = charGraph[22];
            else
                img = self.pat[i].img;
            end;
            DrawGraph( self.pat[i].x-16  , self.pat[i].y-16 , img ) ;
        end;
    end;

}

Fruit = {
    count = 0;
    timer = 0;
	pat = { charGraph[24],charGraph[25],charGraph[26],charGraph[27],charGraph[28],charGraph[29],charGraph[30],charGraph[31] };

	addcount = function( self )
		self.count = self.count + 1;
		if self.count % 100 == 0 then
			self.timer = 200;
		end;
	end;

    draw = function( self )
        local i;
        if self.timer > 0 then		-- timer 1ȏȂt[c\
			self.timer = self.timer - 1;
			i = GameData.stage % 8;	-- t[c̓Xe[WŌ߂
            DrawGraph( FRUIT_X, FRUIT_Y , self.pat[i] ) ;
        end;
    end;
    
    eatcheck = function( self )
	    local zy = math.floor(Player.y / 16 );
	    local zx = math.floor(Player.x / 16 );
		if self.timer > 0 then 		-- \
			if ( FRUIT_MX[1] == zx or FRUIT_MX[2] == zx ) and FRUIT_MY ==  zy then		--t[cH
				PlaySoundMem( eatDwav, 1, 1 );
				GameData.score = GameData.score + 500;
				self.timer = 0;
			end;
		end;
    end;
}

function EatDot()
    local zy = math.floor(Player.y / 16 );
    local zx = math.floor(Player.x / 16 );
    local n = Back.stage[zy][zx];
	local i;

	-- p[H
    if n == BG_NO_POW then
		GameData.score = GameData.score +  100;
		GameData.dotcount = GameData.dotcount - 1;
        Back.stage[zy][zx] = 0;

		for i=0,3 do 
			if Enemy.pat[i].stat ~= 5 then  -- ڋʒ͖
				Enemy.pat[i].stat = 3;
			end;
		end;
		GameData.ijikecount = 500;

		Fruit:addcount();

		StopSoundMem( movewav );			-- ړ~߂
		StopSoundMem( ijikewav );			-- ~߂
		PlaySoundMem( ijikewav, 3, 1 );		-- Đ

	-- hbgH
    elseif n==BG_NO_DOT then
--		TSGL_StopMusic();
--		TSGL_PlayMusicBuffer( eatmml );
		PlaySoundMem( eatDwav, 1, 1 );
        GameData.score = GameData.score +  10;
        GameData.dotcount = GameData.dotcount - 1;
        Back.stage[zy][zx] = 0;
		Fruit:addcount();
    end;
--	print( GameData.dotcount );
	return GameData.dotcount;
end;

function HitCheck()
    local py = math.floor(Player.y / 16 );
    local px = math.floor(Player.x / 16 );

	for i = 0, 3 do
		if Enemy.pat[i].stat ~= 5 then  -- ڋʂ̎̓X[
			ey = math.floor(Enemy.pat[i].y / 16);
			ex = math.floor(Enemy.pat[i].x / 16);
			if px == ex and  py == ey then	--
				if Enemy.pat[i].stat == 4 then  -- 
					PlaySoundMem( eatEwav, 1, 1 );
					GameData.score = GameData.score + 500;
					Enemy.pat[i].stat = 5;
				else  --ʏ
					Player:dead();
					return true;
				end;
			end;
		end;
	end;
	return false;
end;

-- main loop

while( ProcessMessage() == 0 ) do
    if CheckHitKey(1) == 1 then break end;
    -- ʂ
    ClearDrawScreen() ;

	if GameData.stat == 0 then  -- title
		if GetJoypadInputState( 0x1001 ).M then  -- PUSH SPACE
			Back:stageinit(1);
			GameData.dotcount = stagedotcount;
			GameData.stat = 1;
			GameData.count = 200;
			GameData.stage = 1;
			GameData.score = 0;
			Player.stock   = 3;
			Fruit.count = 0;
			TSGL_PlayMusicBuffer( startmml );
		else
			drawText( 300,240, "P-MAN" );
			drawText( 300,260, "PUSH SPACE" );
		end;

	elseif GameData.stat == 1 then -- start
		GameData.count = GameData.count - 1;
		if GameData.count == 0 then 
			Player.stat = 1;
			Player.cur  = 3;
			Player.x    = Player_Start_X;
			Player.y    = Player_Start_Y;

 			Enemy:init( 0,Enemy0_Start_X,Enemy0_Start_Y, charGraph[16], 2, 3, 5 );
			Enemy:init( 1,Enemy1_Start_X,Enemy1_Start_Y, charGraph[17], 0, 0, 20);
			Enemy:init( 2,Enemy2_Start_X,Enemy2_Start_Y, charGraph[18], 0, 1, 40);
			Enemy:init( 3,Enemy3_Start_X,Enemy3_Start_Y, charGraph[19], 0, 1, 60);
			Fruit.timer = 0;
			GameData.stat = 2;
			GameData.ijikecount = 0;
			PlaySoundMem( movewav, 3, 1 );
		end;
		Back:draw();
--		Player:draw();
--		Enemy:draw();
		if math.floor( GameData.count / 10 ) % 2 == 1 then 
			drawText( READY_X,READY_Y, "READY" );
		end;
	elseif GameData.stat == 2 then -- game
		Player:move();
		Enemy:move();
		if HitCheck() then
			GameData.count = 100;
			GameData.stat = 3;
			StopSoundMem( movewav );			-- ړ~߂
			StopSoundMem( ijikewav );			-- ~߂
			TSGL_PlayMusicBuffer( deadmml );
		elseif EatDot() == 0 then 
			GameData.stat = 6;
			StopSoundMem( movewav );			-- ړ~߂
			StopSoundMem( ijikewav );			-- ~߂
		else
			Fruit:eatcheck();

			Back:draw();
			Fruit:draw();
			Player:draw();
			Enemy:draw();
		end;
		if GameData.ijikecount > 0 then
			GameData.ijikecount = GameData.ijikecount - 1;
			if GameData.ijikecount == 0 then
				-- Ȃʏɂǂ
				StopSoundMem( ijikewav );			-- ~߂
				PlaySoundMem( movewav, 3, 1 );
				for i=0,3 do
					if Enemy.pat[i].stat == 4 then
						Enemy.pat[i].stat = 2;
					end;
				end;
			end;
		end;
	elseif GameData.stat == 3 then -- out
		GameData.count = GameData.count - 1;
		if GameData.count == 0 then 
			if Player.stock < 1 then
				GameData.stat = 5;		-- GAME OVER
				GameData.count = 100;
			else
				GameData.stat = 4;
			end;
		end;
		Back:draw();
		Player:draw();
	elseif GameData.stat == 4 then -- restart
		GameData.stat = 1;
		GameData.count = 100;
	elseif GameData.stat == 5 then -- over
		drawText( 100,100, "GAME OVER" );
		GameData.count = GameData.count - 1;
		if GameData.count == 0 then
			GameData.stat = 0;
		end;
	elseif GameData.stat == 6 then -- clear
		Back:draw();
		drawText( 100,100, "STAGE CLEAR" );
		if GameData.stage % 3 == 0 then
			GameData.count = 100;
			GameData.stat  = 7;
		else
			-- next stage
			GameData.dotcount = stagedotcount;
			GameData.stage = GameData.stage + 1;
			GameData.count = 100;
			GameData.stat = 1;
			Back:stageinit(GameData.stage);
		end;
	elseif GameData.stat == 7 then -- coffee break
		drawText( 100,100, "COFFEE BREAK!!" );
		GameData.count = GameData.count - 1;
		if GameData.count == 0 then 
			Back:stageinit();
			GameData.dotcount = stagedotcount;
			GameData.stage = GameData.stage + 1;
			GameData.count = 100;
			GameData.stat = 1;
		end;
	end;
    -- ʂ̓e\ʂɔf
    ScreenFlip() ;

end;

-- cwCugp̏I
DxLib_End();

